#include <cstdio>
#include <cstdlib>
#include <vector>
#include <array>

extern void initialize(std::vector<int> A);
extern std::array<long long, 2> maximum_average(int i, int j);

void my_assert(bool x) {
    if (!x) {
        puts("Wrong input");
        exit(0);
    }
}

int main(){
    int N, Q;
    my_assert(scanf("%d", &N) == 1);
    std::vector<int> A(N);
    for(int i = 0; i < N; i++){
        my_assert(scanf("%d",&A[i]) == 1);
    }
    initialize(A);
    my_assert(scanf("%d", &Q) == 1);
    while(Q--){
        int i, j;
        my_assert(scanf("%d%d",&i,&j) == 2);
        auto t = maximum_average(i, j);
        printf("%lld %lld\n", t[0], t[1]);
    }
}